'*****************************************************************************
' File		install.vbs
' Function	f[^ꊇŃRs[
' How to	wscript.exe dcs.vbs [source path] [destination path]
' Note		XMLŎw肳ꂽtH_t@C̏ꏊփRs[B
'*****************************************************************************

Dim fileXml, objXML
Dim source, target
Dim mname
Dim ffrom, fto, fname
Dim approved, success
Dim check, latest

Set Fso = CreateObject("Scripting.FileSystemObject")
Set ShellApp = CreateObject("Shell.Application")
Set WshShell = CreateObject("WScript.shell")
Set objXML = WScript.CreateObject("MSXML.DOMDocument")

If WScript.Arguments.Count=2 Then
	source = WScript.Arguments(0)
	target = WScript.Arguments(1)
End If

If source <> "" Then
	ffrom = source
Else
	ffrom = Fso.GetFolder(".")
End If
If target <> "" Then
	fto = target
Else
	fto = WshShell.SpecialFolders("Appdata") & "\Yamaha\YS3\data_folder\template_folder\xml_data"
End If

If Fso.FolderExists(fto) Then
	fileXml = replace(ffrom & "\" & WScript.ScriptName,"install.vbs","dcs.xml")
	objXML.load(fileXML)

	approved = False
	success = False

	For Each node In objXML.getElementsByTagName("install")
		For Each item In node.childNodes
			Select Case item.nodeName
				Case "info"
					approved = ShowPreMessage(item)
				Case "data"
					If approved = True Then
						success = InvokeCopyData(item)
					End If
			End Select
		Next
	Next

	Set Fso = Nothing

	If success = True Then
		MsgBox "Installation completed. Please restart Y-S3 to use the added speakers.", vbOKOnly, "Y-S3 Data Installer"
	End If
Else
	MsgBox "Y-S3 is not installed.", vbOKOnly, "Y-S3 Data Installer"
End If

'CXg[OɃbZ[W\
Function ShowPreMessage(item)
	oked = False
	index = 0
	For Each leaf In item.childNodes
		Select Case leaf.nodeName
			Case "model"
				If mname = "" Then
					mname = "The following speaker data will be installed to Y-S3 data folder." + vbNewLine + vbNewLine + vbTab + "Models :" + vbTab + leaf.firstChild.nodeValue
				Else
					mname = mname + vbNewLine + vbTab + vbTab + leaf.firstChild.nodeValue
				End If
		End Select
		index = index + 1 
	Next
	answer = MsgBox ( mname, vbOKCancel, "Y-S3 Data Installer" )
	If answer = vbOK Then
		oked = True
	End If
	ShowPreMessage = oked
End Function

'Rs[s
Function InvokeCopyData(item)
	For Each elmt In item.childNodes
		check = False
		For Each leaf In elmt.childNodes
			Select Case leaf.nodeName
				Case "from"
					fname = leaf.firstChild.nodeValue
				Case "check"
					check = leaf.firstChild.nodeValue
			End Select
		Next
		If elmt.nodeName <> "" Then
			If check = "true" Then
				latest = IsUpdate(ffrom & "\" & fname, fto & "\" & fname)
			Else
				latest = True
			End If
			If latest = True Then

				Select Case elmt.nodeName
					Case "file"
						Fso.CopyFile ffrom & "\" & fname, fto & "\" & fname, True
					Case "folder"
						Fso.CopyFolder ffrom & "\" & fname, fto & "\" & fname, True
				End Select
			End If
		End If
	Next
	InvokeCopyData = True
End Function

'^CX^vmFiTure=Rs[ŐVj
Function IsUpdate(src, dest)
	dim diff, date_src, date_dest
	dim result
	result = False
	If Fso.FileExists(dest) Then
		date_src = Fso.GetFile(src).DateLastModified
		date_dest = Fso.GetFile(dest).DateLastModified
		diff = DateDiff("s", date_src, date_dest)
		If diff < 0 Then
			result = True
		End If
	Else
		result = True
	End If
	IsUpdate = result
End Function

